﻿* Encoding: UTF-8.
*Cumulative curves
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_PRICECRVS*/***************************************************************************.
define !KO_pricecrvs(price1= !charend('/') /price2= !charend('/') /price3= !charend('/') /price4= !charend('/') /clean= !charend('/') /cleansave= !charend('/')
                 /nummiss= !charend('/') !default(1) /numeq= !charend('/') !default(2) /invers= !charend('/') /wbuyer= !charend('/') /labels= !charend('/')
                 /smooth= !charend('/') /graph= !charend('/') /grvar= !charend('/') /save= !charend('/') /ptsave= !charend('/')
                 /tmplt= !charend('/') !default(''))
!let !p1= 'Предельно дорого'
!let !p2= 'Дорого'
!let !p3= 'Дешево'
!let !p4= 'Предельно дешево'
exec.
echo '**** ИЗМЕРИТЕЛЬ ЦЕНОВОЙ ЧУВСТВИТЕЛЬНОСТИ (PSM Ван Вестендорпа) ****'.
!let !ok= 1
!if ((!price1<>!null !and !tail(!price1)=!null) !or (!price2<>!null !and !tail(!price2)=!null) !or (!price3<>!null !and !tail(!price3)=!null) !or (!price4<>!null !and !tail(!price4)=!null)) !then !let !ok= 0
-echo '>ERROR. Неверно задано что-л. из PRICE1, PRICE2, PRICE3, PRICE4.'.
!ifend
!let !pr1= !head(!price1) !let !pr2= !head(!price2) !let !pr3= !head(!price3) !let !pr4= !head(!price4) !let !wbr= !wbuyer !let !lbl= !labels
!let !prlist= !conc(!pr1,' ',!pr2,' ',!pr3,' ',!pr4) !let !nvars= !null !let !prlist2= !null !let !slst= 'stratum1 stratum2 stratum3 stratum4 stratum5' !let !slist= !null
!do !w !in (!prlist)
 !let !nvars= !conc(!nvars,' ') !let !prlist2= !conc(!prlist2,'+',!w) !let !wbr= !tail(!wbr) !let !lbl= !tail(!lbl) !let !slist= !conc(!slist,' ',!head(!slst)) !let !slst= !tail(!slst)
!doend
!let !nvars= !length(!nvars) !let !prlist2= !tail(!prlist2) !let !slist= !conc(!slist,' ',!head(!slst))
!if (!wbr=!null !or !tail(!wbr)<>!null !or !labels<>!null !and (!lbl=!null !or !tail(!lbl)<>!null)) !then !let !ok= 0
-echo '>ERROR. Неверно задано WBUYER или LABELS. WBUYER должно быть списком неотрицательных'.
-echo '>чисел в кол-ве число переменных +1. LABELS, если задано, должно быть'.
-echo '>списком такой же длины, из окавыченных ярлыков.'.
!ifend
!if (!ok) !then
 !if (!clean='NO' !and !cleansave<>!null) !then
- echo '>WARNING. Подкоманда CLEANSAVE будет игнорирована, т.к. CLEAN=NO.'.
 !ifend
 !if (!grvar<>!null !and !ptsave<>!null) !then
- echo '>WARNING. Подкоманда PTSAVE будет игнорирована, т.к. задано GRVAR.'.
 !ifend
 !let !cclist= !null !let !flist= !null !let !plist= !null !let !addvars= !null
 !if (!pr1<>!null) !then !let !cclist= !conc(!cclist,' cc_price1') !let !flist= !conc(!flist,' f_price1') !let !plist= !conc(!plist,' p_price1')
 !else !let !addvars= !conc(!addvars,' f_price1 p_price1')
 !ifend
 !if (!pr2<>!null) !then !let !cclist= !conc(!cclist,' cc_price2') !let !flist= !conc(!flist,' f_price2') !let !plist= !conc(!plist,' p_price2')
 !else !let !addvars= !conc(!addvars,' f_price2 p_price2')
 !ifend
 !if (!pr3<>!null) !then !let !cclist= !conc(!cclist,' cc_price3') !let !flist= !conc(!flist,' f_price3') !let !plist= !conc(!plist,' p_price3')
 !else !let !addvars= !conc(!addvars,' f_price3 p_price3')
 !ifend
 !if (!pr4<>!null) !then !let !cclist= !conc(!cclist,' cc_price4') !let !flist= !conc(!flist,' f_price4') !let !plist= !conc(!plist,' p_price4')
 !else !let !addvars= !conc(!addvars,' f_price4 p_price4')
 !ifend
 !if (!addvars<>!null) !then !let !addvars= !conc('numer',!addvars) !ifend
 !let !slst= !slist !let !lbl= !labels !let !slist2= !null !let !slist2_= !null !let !silist2= !null !let !svlab= !null !let !labels2= !null
 !let !slst22= !slist !let !slist22= !null
 !do !w !in (!wbuyer)
  !if (!w<>0) !then
   !let !slist2= !conc(!slist2,' ',!head(!slst)) !let !slist2_= !conc(!slist2_,',',!head(!slst)) !let !silist2= !conc(!silist2,' i',!head(!slst))
   !let !labels2= !conc(!labels2,' ',!head(!lbl))
  !else
   !let !slist22= !conc(!head(!slst22),' ',!slist22)
  !ifend
  !let !svlab= !conc(!svlab,' ',!head(!slst),' ',!head(!lbl)) !let !slst= !tail(!slst) !let !lbl= !tail(!lbl) !let !slst22= !tail(!slst22)
 !doend
 !let !slist2_= !tail(!slist2_)
 !if (!labels=!null) !then !let !svlab= !null !ifend
 !let !subcmd= '/template='
 !if (!grvar<>!null) !then !let !panel= !conc('/PANEL ROWVAR=',!grvar) !ifend
 !if (!tmplt<>!null) !then
  !let !tmplt1= !conc(!subcmd,!quote(!conc(!tmplt,'pricecrvs1.sgt')))
  !let !tmplt2= !conc(!subcmd,!quote(!conc(!tmplt,'pricecrvs2.sgt')))
  !let !tmplt3= !conc(!subcmd,!quote(!conc(!tmplt,'pricecrvs3.sgt'))) 
 !ifend
 !if (!graph=!null) !then !let !a= 1 !let !b= 1 !let !c= 1 !let !d= 1 !let !e= 1
 !else
  !if (!index(!graph,'A')>0) !then !let !a= 1 !else !let !a= 0 !ifend
  !if (!index(!graph,'B')>0) !then !let !b= 1 !else !let !b= 0 !ifend
  !if (!index(!graph,'C')>0) !then !let !c= 1 !else !let !c= 0 !ifend
  !if (!index(!graph,'D')>0) !then !let !d= 1 !else !let !d= 0 !ifend
  !if (!index(!graph,'E')>0) !then !let !e= 1 !else !let !e= 0 !ifend
 !ifend
 !if (!tail(!slist2)=!null) !then !let !c= 0 !ifend
 !if (!not((!price1<>!null !or !price2<>!null) !and (!price3<>!null !or !price4<>!null))) !then !let !d= 0 !ifend
 !if ((!clean='YES' !or !clean=!null) !and !nvars>1) !then
  !if (!cleansave<>!null) !then
-  comp caseno_= $casenum.
-  exec.
-  format caseno_ (f8.0).
-  var lev caseno_ (nom).
-  var lab caseno_ 'Исходный номер наблюдения'.
  !ifend
- count #nummiss= !prlist (miss).
- select if #nummiss<=!nummiss.
- recode !prlist (else=copy) into #1 to !conc(#,!nvars).
- vector #= #1 to !conc(#,!nvars).
- comp #numeq= 1.
- loop #i= 1 to !nvars-1.
-  comp #count= 0.
-  loop #j= #i+1 to !nvars.
-   do if #(#j)=#(#i).
-    comp #count= #count+1.
-    comp #(#j)= $sysmis.
-   end if.
-  end loop.
-  comp #numeq= max(#numeq,#count+1).
- end loop.
- select if #numeq<=!numeq.
- comp inv#####= 0.
- if !head(!prlist) !do !w !in (!prlist) <!w or !w !doend >!head(!prlist) inv#####= 1.
- var lab inv##### 'Респонденты с инверсией цен (по удалении пропусков и повторений, если заказано)'.
- val lab inv##### 1 'С инверсией' 0 'Без инверсии'.
- temp.
- weight off.
- freq inv#####.
  !if (!invers='DELETE') !then
-  select if not inv#####.
-  echo '>NOTE. Респонденты с инверсией цен (если были) удалены.'.
  !else
-  echo '>NOTE. Инверсии цен (если были) исправлены.'.
-  do if inv#####.
-   recode !prlist (else=copy) into #x1 to !conc(#x,!nvars).
-   vector #x= #x1 to !conc(#x,!nvars).
-   do rep v= !prlist.
-    do if not missing(v).
-     comp v= max(#x1 to !conc(#x,!nvars)).
-     loop #i= 1 to !nvars.
-      do if #x(#i)=v.
-       comp #x(#i)= $sysmis.
-       break.
-      end if.
-     end loop.
-    end if.
-   end rep.
-  end if.
  !ifend
  !if (!cleansave<>!null) !then
-  save out= !cleansave /keep= caseno_ !grvar !prlist.
  !ifend
 !ifend
-set tnumbers labels.
-var lev !pr1 !pr2 !pr3 !pr4 !grvar (ordinal).
 !if (!grvar<>!null) !then !let !bykw= 'BY' !let !layer= !conc('/CATEGORIES VARIABLES=',!grvar,' ORDER= A KEY= VALUE EMPTY= EXCLUDE') !let !var2= 'var2' !ifend
 !if (!save=!null) !then !let !file= 'temp_KO_pricecrvs.sav' !else !let !file= !save !ifend
-OMS /SELECT TABLES /IF COMMANDS= ["CTables"] SUBTYPES= ["Custom Table"] /DESTINATION FORMAT= SAV OUTFILE= !file.
-CTABLES /VLABELS VARIABLES= !prlist DISPLAY= DEFAULT
         /TABLE BY (!prlist2) [COUNT F40.0] + (!prlist2) [COLPCT.COUNT F40.1] !bykw !grvar
         /SLABELS VISIBLE= NO /CLABELS COLLABELS= OPPOSITE
         /CATEGORIES VARIABLES= !prlist ORDER= A KEY= VALUE EMPTY= INCLUDE TOTAL= YES LABEL= 'База' POSITION= AFTER !layer.
-OMSEND.
-dataset close *.
-get file !file /rename (all=command_ subtype_ label_ price !var2 !grvar !flist !plist).
 !if (!grvar<>!null) !then
- sort cases by !grvar.
- split file by !grvar.
 !ifend
-!addvars.
-set results none errors none.
-create c_price1 c_price2 c_price3 c_price4= csum(p_price1 p_price2 p_price3 p_price4).
-split file off.
-do if rtrim(price)='База'.
- recode c_price1 c_price2 c_price3 c_price4 (else=sysmis). 
-end if.
-comp cc_price1= !if (!tail(!price1)=' S') !then lag !ifend (c_price1).
-comp cc_price2= !if (!tail(!price2)=' S') !then lag !ifend (c_price2).
-comp cc_price3= !if (!tail(!price3)=' M') !then lag !ifend (c_price3).
-comp cc_price4= !if (!tail(!price4)=' M') !then lag !ifend (c_price4).
-exec.
-do if rtrim(price)='База'.
- recode !cclist (else=sysmis).
-else.
- recode !cclist (sysmis=0).
-end if.
 !if (!smooth='YES') !then
- create cc_price1 cc_price2 cc_price3 cc_price4= ma(cc_price1 cc_price2 cc_price3 cc_price4 3 1).
- set results list errors list.
- echo '>NOTE. Скорректированные кум% кривые сглажены.'.
 !ifend
-set results list errors list.
-do if cc_price2<cc_price1.
- comp cc_price2= mean(cc_price1,cc_price2).
- comp cc_price1= cc_price2.
-end if.
-do if cc_price3<cc_price2.
- comp cc_price3= mean(cc_price2,cc_price3).
- comp cc_price2= cc_price3.
-end if.
-do if cc_price4<cc_price3.
- comp cc_price4= mean(cc_price3,cc_price4).
- comp cc_price3= cc_price4.
-end if.
-numer stratum1 to stratum5.
 !let !cclist2= !conc('0',!cclist,' 100')
 !do !i= !length(!conc(!blanks(!nvars),' ')) !to 1 !by -1
- comp !conc('stratum',!i)= !head(!tail(!cclist2))-!head(!cclist2).
  !let !cclist2= !tail(!cclist2)
 !doend
 !let !wbr= !wbuyer
-do if rtrim(price)<>'База'.
- comp #ind= char.index(price,'0123456789',1).
- comp price= char.substr(price,#ind,char.rindex(price,'0123456789',1)-#ind+1).
- loop #i= 1 to 2.
-  comp #ind= char.index(rtrim(price),' ').
-  if #ind>1 price= concat(char.substr(price,1,#ind-1),char.substr(price,#ind+1)).
- end loop.
- comp revenue= (0 !do !s !in (!slist) +!head(!wbr)*!s !let !wbr= !tail(!wbr) !doend)*number(price,f8).
-end if.
-var lab price 'Цена' c_price1 !quote(!conc('Кум% ',!p1)) c_price2 !quote(!conc('Кум% ',!p2)) c_price3 !quote(!conc('Кум% ',!p3)) c_price4 !quote(!conc('Кум% ',!p4))
         cc_price1 !quote(!conc('Скоррект. кум% ',!p1)) cc_price2 !quote(!conc('Скоррект. кум% ',!p2)) cc_price3 !quote(!conc('Скоррект. кум% ',!p3)) cc_price4 !quote(!conc('Скоррект. кум% ',!p4))
         revenue 'Доход' !svlab.
-format cc_price1 to stratum5 (pct5) /revenue (f8).
-comp filter_$= 1.
-if rtrim(price)='База' filter_$= 0.
-filter by filter_$.
-recode !slist (lo thru 0=0) (100 thru hi=100).
-exec.
 !let !copy= !slist !let !slist= !null !let !copy2= !slist2 !let !slist2= !null
 !do !w !in (!copy) !let !slist= !conc(!w,' ',!slist) !let !copy= !tail(!copy) !doend
 !do !w !in (!copy2) !let !slist2= !conc(!w,' ',!slist2) !let !copy2= !tail(!copy2) !doend
 !if (!a) !then
- GRAPH /LINE(AREA)= VALUE(!slist) BY price !tmplt1 /TITLE= 'Категории покупателей и непокупателей' !panel.
 !ifend
 !if (!b) !then
- temp.
- recode !slist22 (else=0).
- GRAPH /LINE(AREA)= VALUE(!slist) BY price !tmplt1 /TITLE= 'Покупатели' !panel.
 !ifend
 !if (!c) !then
- temp.
- comp m= sum(!slist2_).
- comp m= 100/(m+(m=0)).
- do rep v= !slist2.
-  comp v= v*m.
- end rep.
- recode !slist22 (else=0).
- GRAPH /LINE(AREA)= VALUE(!slist) BY price !tmplt1 /TITLE= 'Покупатели как 100%' !panel.
 !ifend
 !if (!d) !then
- temp.
- comp cc_price3= 100-cc_price3.
- comp cc_price4= 100-cc_price4.
- var lab cc_price1 !quote(!p1) cc_price2 !quote(!p2) cc_price3 !quote(!conc('100% - ',!p3)) cc_price4 !quote(!conc('100% - ',!p4)).
- GRAPH /LINE(MULTIPLE)= VALUE(!cclist) BY price !tmplt2 /TITLE= 'Ценовые точки' !panel.
  !if (!grvar=!null) !then
-  temp.
-  recode price (convert) into price_.
-  comp cc_price3= 100-cc_price3.
-  comp cc_price4= 100-cc_price4.
-  set mxloops 1000.
-  matrix.
-  get price /var= price_.
   !if (!pr1<>!null) !then
-   get cc1 /var= cc_price1.
   !ifend
   !if (!pr2<>!null) !then
-   get cc2 /var= cc_price2.
   !ifend
   !if (!pr3<>!null) !then
-   get cc3 /var= cc_price3.
   !ifend
   !if (!pr4<>!null) !then
-   get cc4 /var= cc_price4.
   !ifend
-  print /title 'Цена напротив точек перекреста на графике: Min и Max значения.'.
   !do !pt !in ('PMC OPP IPP PME')
    !if (!pt='PMC') !then !let !pr_a= !pr2 !let !cc_a= 'cc2' !let !pr_b= !pr4 !let !cc_b= 'cc4'
    !else !if (!pt='OPP') !then !let !pr_a= !pr1 !let !cc_a= 'cc1' !let !pr_b= !pr4 !let !cc_b= 'cc4'
    !else !if (!pt='IPP') !then !let !pr_a= !pr2 !let !cc_a= 'cc2' !let !pr_b= !pr3 !let !cc_b= 'cc3'
    !else !if (!pt='PME') !then !let !pr_a= !pr1 !let !cc_a= 'cc1' !let !pr_b= !pr3 !let !cc_b= 'cc3'
    !ifend !ifend !ifend !ifend
    !if (!pr_a<>!null !and !pr_b<>!null) !then
-    comp d= !cc_a-!cc_b.
-    comp d= rnd(d*1E+9)/1E+9.
-    comp min= cmin(abs(d)).
-    do if min=0.
-     comp ilst= cmax((abs(d)=min)&*t(1:nrow(d))).
-     comp ifst= nrow(d)+1-cmax((abs(d)=min)&*t(nrow(d):1)).
-     comp pt= {price(ifst),price(ilst)}.
-    else.
-     loop i= 2 to nrow(d)-1. 
-      do if abs(d(i))=min.
-       do if not d(i)*d(i-1).
-        comp i2= i-1.
-        break.
-       else if not d(i)*d(i+1).
-        comp i2= i+1.
-        break.
-       end if.
-      end if.
-     end loop.
-     comp pt= price(i)+min*(price(i2)-price(i))/(min+abs(d(i2))).
-     comp pt= {pt,pt}.
-    end if.
-    print pt /title ' ' /rlab= !quote(!pt) /format= f8.4 /space= 0.
     !if (!ptsave<>!null) !then
-     save {!quote(!pt),pt} /out= !ptsave /vari= point minprice maxprice /string= point.
     !ifend
    !ifend
   !doend
-  end matrix.
  !ifend
 !ifend
 !if (!e) !then
- GRAPH /LINE(AREA)= VALUE(revenue) BY price !tmplt3 /TITLE= 'Доход' !panel.
 !ifend
 !if (!save<>!null) !then
- var width all (8).
- format p_price1 p_price2 p_price3 p_price4 c_price1 c_price2 c_price3 c_price4 cc_price1 cc_price2 cc_price3 cc_price4 stratum1 stratum2 stratum3 stratum4 stratum5 (pct5.1).
- save outfile !file /keep= price !grvar f_price1 f_price2 f_price3 f_price4 p_price1 p_price2 p_price3 p_price4 c_price1 c_price2 c_price3 c_price4
                            cc_price1 cc_price2 cc_price3 cc_price4 stratum1 stratum2 stratum3 stratum4 stratum5 revenue.
 !ifend
-new file.
 !if (!save=!null) !then
- erase file !file.
 !ifend
!ifend
!enddefine.

*/*!KO_CUMCLUG*/***************************************************************************.
define !KO_cumclug(vars= !charend('/') /grvar= !charend('/') /matrxs= !charend('/') /measure= !charend('/') /missing= !charend('/'))
set mxloops 500 results none errors none.
!let !vrs= !null !let !nv= !null
!do !w !in (!vars)
 !let !vrs= !conc(!vrs,',',!w) !let !nv= !conc(!nv,' ')
!doend
!let !nv= !length(!nv)
select if not missing(!grvar).
!if (!missing='LISTWISE') !then
-select if nmiss(!tail(!vrs))=0.
!ifend
!let !vrs= !vars
!do !i=1 !to !nv
 !let !v= !head(!vrs) !let !vrs= !tail(!vrs)
-aggregate /outfile= !conc('temp_KO_cumclug_',!i,'.sav') /break= !grvar !v /freq####= N.
!doend
dataset close *.
match files /file= 'temp_KO_cumclug_1.sav' /rename (all=!grvar level gr_).
!do !i= 2 !to !nv
-match files /file= * /file= !conc('temp_KO_cumclug_',!i,'.sav') /rename (all=!grvar level !conc('var',!i)) /by !grvar level.
!doend
format !grvar (f8).
sort cases level !grvar.
select if not missing(level).
casestovars /id= level /index= !grvar /groupby= index /separ= ''.
recode all (sysmis=0).
comp endvar= 1.
comp lev= level.
create /level to endvar= csum(level to endvar).
comp #nv= 0.
string #nv2 (a8).
do rep vars= level to endvar.
-comp #nv= #nv+1.
end rep.
comp #nv2= ltrim(string(#nv,f8)).
do if $casenum=1.
-write outfile= 'temp_KO_cumclug_0.sps' /'do rep x= level to endvar /b= #b1 to #b' #nv2(a8) '.'.
end if.
exec.
sort cases by lev (d).
include file 'temp_KO_cumclug_0.sps'.
-if $casenum=1 b= x.
-comp x= x/b*100.
end rep.
sort cases by lev.
set results list errors list.
matrix.
get m /names= names.
comp m= m(:,3:(ncol(m)-1)).
comp names= names(3:(ncol(names)-1)).
comp nr= nrow(m).
comp nc= ncol(m).
comp ngr= nc/!nv.
comp dd= make(ngr,ngr,0).
loop i= 1 to !nv.
-comp d= make(ngr,ngr,0).
-comp m2= m(:,i:nc:!nv).
-do if i=1.
- comp names= names(i:nc:!nv). 
-end if.
-comp m3_= 0.
-loop i2= 1 to nr.
- comp m3= kroneker(make(ngr,1,1), m2(i2,:)).
- comp m3= m3-t(m3).
  !if (!measure='AUTOCORR') !then
-  comp d= d+m3&*m3_.
-  comp m3_= m3.
  !else
-  comp m3= abs(m3).
   !if (!measure='CHEB') !then
-   comp d= m3&*(m3>d)+d&*(m3<=d).
   !else
-   comp d= d+m3.
   !ifend
  !ifend
-end loop.
 !if (!measure='AUTOCORR') !then
- do if any(d<0).
-  print i /title '>WARNING. Отрицательные автокорр-ные расстояния есть в матрице для переменной №:'.
-  print (msum(d<0)/2) /title ' Их число:' /space= 0.
-  print /title ' Они обращены в положительные.' /space= 0.
-  comp d= abs(d).
- end if.
 !ifend
 !if (!matrxs='CONCAT' !and !tail(!vars)<>!null) !then
- comp dd= block(dd,d-(d=0)).
 !else
- comp dd= dd+d.
 !ifend
end loop.
!if (!matrxs='CONCAT' !and !tail(!vars)<>!null) !then
-comp dd= (dd=0)*mmax(dd)*1.25+dd.
-comp dd= (dd+(dd=-1))((ngr+1):nrow(dd),(ngr+1):ncol(dd)).
-save dd /outfile= * /names= names.
-write kroneker(t(1:!nv),make(ngr,1,1)) /outfile= 'temp_KO_cumclug_n.sps' /field= 1 to 2 /format= n2.
-write kroneker(make(!nv,1,1),t(names)) /outfile= 'temp_KO_cumclug_g.sps' /field= 1 to 5 /format= a5.
-write nrow(dd) /outfile= 'temp_KO_cumclug_s.sps' /field= 1 to 8 /format= f8.
!else
-comp dd= dd/!nv.
-comp rowtype= make(ngr,1,'PROX').
-comp varname= t(names).
-comp names= {'rowtype_','varname_',names}.
-save {rowtype,varname,dd} /outfile= * /names= names /strings= rowtype_ varname_.
!ifend
end matrix.
!if (!matrxs='CONCAT' !and !tail(!vars)<>!null) !then
-set results none errors none.
-matrix.
-read s /file= 'temp_KO_cumclug_s.sps' /field= 1 to 8 /format= f8 /size= 1. 
-read v /file= 'temp_KO_cumclug_n.sps' /field= 1 to 2 /format= a1 /size= {s,2}.
-read g /file= 'temp_KO_cumclug_g.sps' /field= 1 to 5 /format= a1 /size= {s,5}.
-write {make(s,1,'v'),v,g} /outfile= 'temp_KO_cumclug_0.sps' /field= 1 to 8 /format= a1.
-end matrix.
-matrix.
-get dd.
-read names /file= 'temp_KO_cumclug_0.sps' /field= 1 to 8 /format= a8 /size= nrow(dd).
-comp names_= {'rowtype_';'varname_';names}.
-comp rowtype= make(nrow(dd),1,'PROX').
-save {rowtype,names,dd} /outfile= * /names= names_ /strings= rowtype_ varname_.
-end matrix.
-set results list errors list.
!ifend
!if (!measure=!null) !then !let !lab= 'BLOCK' !else !let !lab= !measure !ifend
val lab rowtype_ 'PROX' !quote(!conc('DISSIMILARITY ',!lab)).
CLUSTER /matrix= in(*) /METHOD COMPLETE /PRINT NONE /PLOT DENDROGRAM.
!do !i=1 !to !nv
-erase file !conc('temp_KO_cumclug_',!i,'.sav').
!doend
!if (!matrxs='CONCAT' !and !tail(!vars)<>!null) !then
-erase file 'temp_KO_cumclug_n.sps'.
-erase file 'temp_KO_cumclug_g.sps'.
-erase file 'temp_KO_cumclug_s.sps'.
!ifend
erase file 'temp_KO_cumclug_0.sps'.
!enddefine.
